#include <iostream>
#include <fstream>
#include <ctime>
#include "structs.cpp"
#include "oldrun.h"
#include "discounts.h"
#include "run.h"
#include "config.h"
#include "TNF.h"
#include "skelet.h"
#include "runcomp.h"
#include "runcomp2.h"
#include "induction.h"
using namespace std;

void copyabstrsymbol (abstrsymbol &a, abstrsymbol &b) { //That is, copy a into b
	b.baselen=a.baselen;
	b.base=new bool[b.baselen];
	for (int i=0; i<b.baselen; i++) b.base[i]=a.base[i];
	b.exp=a.exp;
	return;
};

void appendabstrsymbol (abstrconfig& c, abstrsymbol& s) {
	//WARNING: Will only work when more space than c.len has been reserved for c
	copyabstrsymbol(s,c.a[c.len]);
	c.a[c.rhsindex].next=&c.a[c.len];
	c.a[c.len].prev=&c.a[c.rhsindex];
	c.a[c.len].arrayaddress=c.len;
	c.rhsindex=c.len;
	c.len++;
}

void copyabstrconfig (abstrconfig &c, abstrconfig &d) {
	copyabstrconfig(c,d,1);
}

void copyabstrconfig (abstrconfig &c, abstrconfig &d, int expansionrate) { //That is, copy c into d
	d.s=c.s;
	d.pos=c.pos;
	d.side=c.side;
	d.len=c.len;
	d.a=new abstrsymbol[d.len*expansionrate];
	int cj=c.lhsindex;
	for (int i=0; i<d.len; i++) {
		d.a[i].arrayaddress=i; //might as well clean it up while we're at it
		copyabstrsymbol(c.a[cj],d.a[i]);
		if (i==0) d.a[i].prev=NULL;
		else d.a[i].prev=&d.a[i-1];
		if (i==d.len-1) d.a[i].next=NULL;
		else d.a[i].next=&d.a[i+1];
		if (i<d.len-1) cj=c.a[cj].next->arrayaddress;
	}
	d.lhsindex=0;
	d.rhsindex=d.len-1;
	return;
};

void copyabstrconfig (abstrconfig &c, abstrconfig &d, int expansionrate, int &pointertokeeptrackof) {
	//That is, copy c into d, modifying pointertokeeptrackof
	d.s=c.s;
	d.pos=c.pos;
	d.side=c.side;
	d.len=c.len;
	d.a=new abstrsymbol[d.len*expansionrate];
	int cj=c.lhsindex;
	for (int i=0; i<d.len; i++) {
		d.a[i].arrayaddress=i; //might as well clean it up while we're at it
		copyabstrsymbol(c.a[cj],d.a[i]);
		if (cj==pointertokeeptrackof) pointertokeeptrackof=i;
		if (cj==c.pos) d.pos=i;
		if (i==0) d.a[i].prev=NULL;
		else d.a[i].prev=&d.a[i-1];
		if (i==d.len-1) d.a[i].next=NULL;
		else d.a[i].next=&d.a[i+1];
		if (i<d.len-1) cj=c.a[cj].next->arrayaddress;
	}
	d.lhsindex=0;
	d.rhsindex=d.len-1;
	return;
};

expr readlinexp (char* st, int &i) {
//Cases:b, aN, aN+b.
//So we check to see if there's a + and/or an N there.
	int p=0; //0 for b, 1 for aN, 2 for aN+b
	int a, b; expr exp; //to hold the answer
	for (int j=i; st[j]!='}'; j++) if (st[j]=='+' || st[j]=='N') p++; //So that we don't have to modify i while we're looking
	switch (p) {
		case 0:
			b=chartodigit(st[i]);
			i++;
			while (st[i]!='}') {
				b*=10;
				b+=chartodigit(st[i]);
				i++;
			}
			exp.a=0;
			exp.b=b;
			return exp;			
			break;
		case 1://possibility that it's just N
			if (st[i]=='N')
				a=1;
			else {
				a=chartodigit(st[i]);
				i++;
				while (st[i]!='N') {
					a*=10;
					a+=chartodigit(st[i]);
					i++;
				}
			}
			i++;
			exp.a=a;
			exp.b=0;
			return exp;		
			break;
		case 2://possibility that it's just N+b
			if (st[i]=='N')
				a=1;
			else {
				a=chartodigit(st[i]);
				i++;
				while (st[i]!='N') {
					a*=10;
					a+=chartodigit(st[i]);
					i++;
				}
			}
			i+=2;
			exp.a=a;
			b=chartodigit(st[i]);
			i++;
			while (st[i]!='}') {
				b*=10;
				b+=chartodigit(st[i]);
				i++;
			}
			exp.b=b;
			return exp;			
			break;
	}
	return exp;
}

void readin (char* st, int len, int& i, abstrconfig& c, int& ci) {
	int j, k;
	switch (st[i]) {
		case '<':
			c.pos=ci-1;
			c.side=1;
			i++;
			break;
		case '>':
			c.pos=ci;
			c.side=0;
			i++;
			break;
		case '{':
			i++;
			j=0;
			while (st[i]=='0' || st[i]=='1') {
				i++;
				j++;
			}
			i-=j;
			c.a[ci].base=new bool[j];
			c.a[ci].baselen=j;
			cout << "i=" << i << ".\n";
			k=i;
			for (i=i; i<k+j; i++) {
				if (st[i]=='0') c.a[ci].base[i-k]=0;
				else c.a[ci].base[i-k]=1;
			}
			i+=3;
			c.a[ci].exp=readlinexp(st,i);
			c.a[ci].arrayaddress=ci;
			if (ci>0) c.a[ci].prev=&c.a[ci-1];
			else c.a[ci].prev=NULL;
			if (ci<c.len-1) c.a[ci].next=&c.a[ci+1];
			else c.a[ci].next=NULL;
			ci++;
			i++;
			break;
		default: //0 or 1
			if (st[i+1]!='^') {
				c.a[ci].base=new bool[1];
				if (st[i]=='0') c.a[ci].base[0]=0;
				else c.a[ci].base[0]=1;
				c.a[ci].baselen=1;
				c.a[ci].exp.a=0;
				c.a[ci].exp.b=1;
				c.a[ci].arrayaddress=ci;
				if (ci>0) c.a[ci].prev=&c.a[ci-1];
				else c.a[ci].prev=NULL;
				if (ci<c.len-1) c.a[ci].next=&c.a[ci+1];
				else c.a[ci].next=NULL;
				ci++;
				i++;
				break;				
			}
			else {
				c.a[ci].base=new bool[1];
				if (st[i]=='0') c.a[ci].base[0]=0;
				else c.a[ci].base[0]=1;
				c.a[ci].baselen=1;
				i+=3;
				c.a[ci].exp=readlinexp(st,i);
				c.a[ci].arrayaddress=ci;
				if (ci>0) c.a[ci].prev=&c.a[ci-1];
				else c.a[ci].prev=NULL;
				if (ci<c.len-1) c.a[ci].next=&c.a[ci+1];
				else c.a[ci].next=NULL;
				ci++;
				i++;				
			}
			break;
	}
	return;
}

bool abstrconfigin (char* st, int len, abstrconfig& c) {
	//1 if a valid configuration, 0 otherwise
	int depth=0;
	bool inexp=0;
	int numsymbs=0;
	bool hasonecarat=0;
	bool onenplusperexp=0;
	for (int i=0; i<len-2; i++) {
		cout << "NOW VERIFYING CHARACTER NUMBER " << i << ".\n";
		switch (st[i]) {
			case 'N':
				if (depth==0 || !inexp) {cout << "ERR: Cannot use variable symbol N outside of exponent at position " << i << ".\n"; return 0;}
				if (onenplusperexp) {cout << "ERR: Cannot use second variable symbol N in single exponent at position " << i << ".\n"; return 0;}
				onenplusperexp=1;
				break;
			case '+':
				if (depth==0 || !inexp) {cout << "ERR: Cannot use operator symbol + outside of exponent at position " << i << ".\n"; return 0;}
				if (st[i-1] != 'N') {cout << "ERR: Cannot have + at position " << i << " without N before it.\n"; return 0;}
				break;
			case '<':
				if (depth==1 || inexp || i==0 || hasonecarat) {
					if (depth==1) cout << "ERR: left-pointing tape head in braces at position " << i << ".\n";
					if (inexp) cout << "ERR: left-pointing tape head in exponent at position " << i << ".\n";
					if (i==0) cout << "ERR: left-pointing tape head at left end of tape.\n";
					if (hasonecarat) cout << "ERR: left-pointing tape head at position " << i << " after tape head.\n"; 
					return 0;
				}
				hasonecarat=1;
				break;
			case '>':
				if (depth==1 || inexp || i==len-3 || hasonecarat) {
					if (depth==1) cout << "ERR: right-pointing tape head in braces at position " << i << ".\n";
					if (inexp) cout << "ERR: right-pointing tape head in exponent at position " << i << ".\n";
					if (i==0) cout << "ERR: right-pointing tape head at right end of tape.\n";					
					if (hasonecarat) cout << "ERR: right-pointing tape head at position " << i << " after tape head.\n"; 
					return 0;
				}
				hasonecarat=1;
				break;
			case '{':
				if (depth==1) {cout << "ERR: left brace within braces at position " << i << ".\n"; return 0;}
				depth++;
				if (!inexp) numsymbs++;
				break;
			case '}':
				if (depth==0) {cout << "ERR: right brace outside of braces at position " << i << ".\n"; return 0;}
				if (!inexp && (i==len-3 || st[i+1] != '^')) {cout << "ERR: base with no exponent ending at position" << i << ".\n"; return 0;}
				depth--;
				if (inexp) inexp=0;
				onenplusperexp=0;
				break;
			case '^':
				if (inexp) {cout << "ERR: Exponentiation within exponent at position " << i << ".\n"; return 0;}
				if (depth==1) {cout << "ERR: Exponentiation within base at position " << i << ".\n"; return 0;}
				if (i==0) {cout << "ERR: Exponentiation at beginning of tape."; return 0;}
				if (i==len-3) {cout << "ERR: Exponentiation at end of tape."; return 0;}
				if (st[i+1]!='{') {cout << "ERR: Exponentiation will need a brace at position " << i << ".\n"; return 0;}
				inexp=1;
				break;
			case '0':
				if (inexp && i>=1 && st[i-1]=='{') {cout << "ERR: Cannot begin exponent with a leading zero at position " << i << ".\n"; return 0;}
				if (!inexp && depth==0) numsymbs++;
				break;
			case '1':
				if (!inexp && depth==0) numsymbs++;
				break;
			default:
				if (!inexp) {cout << "ERR: " << st[i] << " is an unrecognizable base character at position " << i << ".\n"; return 0;}
				if (st[i]!='2' && st[i]!='3' && st[i]!='4' && st[i]!='5' && st[i]!='6' && st[i]!='7' && st[i]!='8' && st[i]!='9') {
					cout << "ERR: " << st[i] << " is an unrecognizable exponent character at position " << i << ".\n";
					return 0;
				}
				break;
		}
	}
	if (depth==1) {cout << "ERR: Cannot end tape in braces.\n"; return 0;}
	if (inexp) {cout << "ERR: Cannot end tape in exponent.\n"; return 0;}
	if (!hasonecarat) {cout << "ERR: Tape missing head.\n"; return 0;}
	if (st[len-2]!=' ') {cout << "ERR: Single whitespace needed between tape and state.\n"; return 0;}
	cout << "VALID CONFIGURATION\n";
	switch (st[len-1]) {
		case 'A':
			c.s=0;
			break;
		case 'B':
			c.s=1;
			break;
		case 'C':
			c.s=2;
			break;
		case 'D':
			c.s=3;
			break;
		case 'E':
			c.s=4;
			break;
		case 'H':
			c.s=127;
			break;
		default:
			cout << "ERR: Cannot read state.\n";
			return 0;
	}
	c.a=new abstrsymbol[numsymbs];
	c.len=numsymbs;
	c.lhsindex=0;
	c.rhsindex=c.len-1;
	int i=0, ci=0;
	while (i<len-2) readin(st,len,i,c,ci);
	return 1;
};

void abstrsymbolout (abstrsymbol &cs) {
	if (cs.baselen>1 && !(cs.exp.a==0 && cs.exp.b==1)) {
		cout << "{";
		boolout(cs.base,cs.baselen);
		cout << "}^{"; 
		if (cs.exp.a==0) cout << cs.exp.b;
		else if (cs.exp.a==1) {
			if (cs.exp.b==0) cout << "N";
			else cout << "N+" << cs.exp.b;
		}
		else if (cs.exp.b==0) cout << cs.exp.a << "N";
		else cout << cs.exp.a << "N+" << cs.exp.b;
		cout << "}";
	}
	else if (cs.baselen==1 && !(cs.exp.a==0 && cs.exp.b==1)) {
		boolout(cs.base,cs.baselen);
		cout << "^{"; 
		if (cs.exp.a==0) cout << cs.exp.b;
		else if (cs.exp.a==1) {
			if (cs.exp.b==0) cout << "N";
			else cout << "N+" << cs.exp.b;
		}
		else if (cs.exp.b==0) cout << cs.exp.a << "N";
		else cout << cs.exp.a << "N+" << cs.exp.b;
		cout << "}";
	}
	else boolout(cs.base,cs.baselen);
	return;
}

void abstrconfigout (abstrconfig &c) {
	int j=c.lhsindex;
	for (int i=0; i<c.len; i++) {
		if (c.pos==i && c.side==0) cout << ">";
		abstrsymbolout (c.a[j]);
		if (i<c.len-1) j=c.a[j].next->arrayaddress;
		if (c.pos==i && c.side==1) cout << "<";
	}
	cout << " ";
	if (c.s==0) cout << "A";
	else if (c.s==1) cout << "B";
	else if (c.s==2) cout << "C";
	else if (c.s==3) cout << "D";
	else if (c.s==4) cout << "E";
	else if (c.s==127) cout << "H";
	return;
};

bool yields (machine m, abstrconfig &c, abstrconfig &d, expr num) { //WARNING: not finished yet
//Does config c yield config d in num steps according to the rules of m?
//Will try a simple induction: let N=0; see if c yields d.
// Then assume it's true when N=K and see if it's true when N=K+1.
//For instance, according to HNR#9, >1^{2N+1} C yields 1{10}^{N}> A in 2N+1 steps.
// So, we'll check whether >1^{3} C yields 1{10}^{1}> A in 3 steps, and then
// assuming >1^{2K+1} C yields 1{10}^{K}> A in 2K+1 steps, we'll prove that
// >1^{2K+3} C yields 1{10}^{K+1}> A in 2K+3 steps.
// The assumption is used wherever felicitous; hence, at the beginning,
// we change to 1{10}^{K}>11 A in 2K+1 steps, and then get
// 1{10}^{K+1}> A in two more.
	abstrconfig c0, d0;
	//Copy s, pos, side, len;
	c0.s=c.s; d0.s=d.s;
	c0.pos=c.pos; d0.pos=d.pos;
	c0.side=c.side; d0.side=d.side;
	c0.len=c.len; d0.len=d.len;
	return 0;
}

bool eqlexactsymb (abstrsymbol& s, abstrsymbol& t) {
	if (s.baselen == t.baselen && s.exp.a == t.exp.a && s.exp.b == t.exp.b) {
		for (int i=0; i<s.baselen; i++)
			if (s.base[i]!=t.base[i])
				return 0;
		return 1;
	}
	return 0;
}

bool eqlexact (abstrconfig &c, abstrconfig &d) {
//Must check abstrsymbol* a; bool side; int s, pos, len;
//The particular indices for the memory are not considered to matter
	if (c.side == d.side && c.s == d.s && c.pos == d.pos && c.len == d.len) {
		int i=c.lhsindex, j=d.lhsindex;
		while (c.a[i].next!=NULL&&d.a[j].next!=NULL) {
			if (!eqlexactsymb(c.a[i],d.a[j])) {
				return 0;
			}
			i=c.a[i].next->arrayaddress;
			j=d.a[j].next->arrayaddress;
		}
		if (c.a[i].next!=NULL||d.a[j].next!=NULL) //If either abstrconfig has more to it
			return 0;
	}
	else return 0;
	return 1;
}

bool spill (abstrconfig &c, int where, bool reorganize) {
	if (where>=c.len || where < 0) {
		cout << "ERR: Symbol # " << where << " is past the end of the configuration.\n";
		return 0;
	}
	else {
		if (reorganize) {
		}
		else {
			
		}
	}
	return 1;
}

bool runonassumptions(machine& m, config& c, assumptionlist& al, int numbigsteps) {
	//What we have to do, we have to do for numbigsteps big steps.
	//We'll record the number of individual steps taken along the way.
	int totNumTaken=0, numTaken;
	bool hasApplied;
	int i;
	compconfig c2;
	c2.a = new compsymbol[1000];
	for (int whichsymbol = 0; whichsymbol < 1000; whichsymbol++) c2.a[whichsymbol].base = new bool[100];
	for (int stepCounter = 0; stepCounter < numbigsteps; stepCounter++) {
		//We go through each assumption in assumptionlist a,
		//seeing if it applies. If none apply, just run for one step.
		hasApplied=0;
		for (int j = 0; j < al.len; j++) {
			//apply returns 0 if the assumption does not apply.
			numTaken=apply (m, c, al.a[j]);
			//If the assumption has applied, then note that and break.
			if (numTaken > 0) {
				totNumTaken+=numTaken;
				if (compressfor1st(c,c2)) {
					compconfigoutfor1st(c2);
					cout << totNumTaken << "\n";
				}
				hasApplied=1;
				break;
			}
		}
		//If we have gone through all of the assumptions, and none has applied,
		//then just run for one step.
		if (!hasApplied) {
			i = c.pos;
			if (c.t.a[i]==0) {
				c.t.a[i]=m.s[c.s].z.p;
				if (m.s[c.s].z.d==0) i--;
				else i++;
				c.s=m.s[c.s].z.t;
				c.pos=i;
			}
			else {
				c.t.a[i]=m.s[c.s].o.p;
				if (m.s[c.s].o.d==0) i--;
				else i++;
				c.s=m.s[c.s].o.t;
				c.pos=i;
			}
			if (i==-1) {
				cout << "GOT TO THE LEFT END!\n";
				return 0;
			}
			if(i==c.len) {
				cout << "GOT TO THE RIGHT END!\n";
				return 0;
			}
			if (c.s==127) {
				cout << "HALT!\n";
				return 1;
			}			
			totNumTaken++;
			if (compressfor1st(c,c2)) {
				compconfigoutfor1st(c2);
				cout << totNumTaken << "\n";
			}
		}
	}
	return true;
}

int apply (machine& m, config& c, assumption &as) {
//Attempts to apply as to c and return the # steps taken.
//Returns 0 if as does not apply.
//For now, we will only work with assumptions having one abstract substring with exponent exactly N
//and position on a side (and not at the abstract substring).
//WARNING: The head of as.output is not where the head should end up,
//but rather, where it should begin!
	//cout << "Beginning apply.\n";
	int LR=LR_Type(as.input); //Returns -2 if the abstrconfig has no abstract substring at an extremum
	if (LR != -2) {
		//Then we need to figure out if there is a match,
		//and if so, how far it goes.
		int arrayAddy;
		int backcounter=0;
		int forwardcounter=0;
		bool wasmatch = largestSubstringUpToAbstrPointMatch(c,as.input,arrayAddy,backcounter,forwardcounter);
		//Returns how far to go, false if not match. Saves progress in arrayAddy
		if (wasmatch) {
			int answer;
			if (LR == 1) {
				answer = countNumTimesEqual(c,c.pos-backcounter,as.input,arrayAddy,0); //Counts how many times
																							   //c follows a's pattern
			}
			else if (LR == 2) {
				answer = countNumTimesEqual(c,c.pos+forwardcounter,as.input,arrayAddy,1);
			}
			confReplace(c,as.output,answer); //Will automatically get the placement right
			return eval(as.num,answer);
		}
		else return 0;
	}
	else {
		//Then a is of mid type.
		cout << "Hey your as.input is not of left or right type.\n";
		return 0;
	}
}


int LR_Type (abstrconfig& ac) {
	//If a has an abstract substring at an extremum,
	//outputs 1 for left, 2 for right.
	//Outputs -2 if a doesn't.
	if (ac.len == 1) {
		if (ac.side == 1) return 1;
		else return 2;
	}
	else {
		if (ac.a[ac.lhsindex].exp.a >= 1) return 1;
		else if (ac.a[ac.rhsindex].exp.a >=1) return 2;
		else return -2;
	}
}

bool largestSubstringUpToAbstrPointMatch (config& c, abstrconfig& ac, int& arrayAddy, int& backcounter, int& forwardcounter) {
//Returns false if they do not match.
//For now we will assume a very simple form for the abstrconfig:
//every base has length 1, and every exponent is 1, until the end.
//The head position may be anywhere.
//Expects backcounter, forwardcounter to start out with values of 0.
	//First we must make sure the states match!
	if (c.s != ac.s) return false;
	//Now, we head to the right and to the left using addyL and addyR.
	//Whichever side hits the abstract expression becomes the provisionary arrayAddy.
	//If both finish their course, in one way or another, then we save in backcounter,
	//forwardcounter, respectively, how far this went on c.
	int addyL, addyR;
	addyL=addyR=ac.pos;
	if (ac.len == 1) {
		arrayAddy = addyL;
		return true;
	}
	
	cout << "Now checking c's symbol " << c.t.a[c.pos] << " at tape head at place " << c.pos << " against ac's " << ac.a[addyL].base[0] << " at tape head at position " << addyL << ".\n";
	if (c.t.a[c.pos] != ac.a[addyL].base[0]) return false;
	
	while (addyL != ac.lhsindex && ac.a[addyL].prev->exp.a == 0) {
		addyL = ac.a[addyL].prev->arrayaddress;
		backcounter++;
		cout << "Now checking c's symbol " << c.t.a[c.pos - backcounter] << " at place " << c.pos - backcounter << " against ac's " << ac.a[addyL].base[0] << " at position " << addyL << ".\n";
		if (c.pos - backcounter < 0 || c.t.a[c.pos - backcounter] != ac.a[addyL].base[0]) return false;
	}
	
	while (addyR != ac.rhsindex && ac.a[addyR].next->exp.a == 0) {
		addyR = ac.a[addyR].next->arrayaddress;
		forwardcounter++;
		cout << "Now checking c's symbol " << c.t.a[c.pos + forwardcounter] << " at place " << c.pos + forwardcounter << " against ac's " << ac.a[addyR].base[0] << " at position " << addyR << ".\n";
		if (c.pos + forwardcounter >= c.len || c.t.a[c.pos + forwardcounter] != ac.a[addyR].base[0]) return false;
	}
	
	if (addyL != ac.lhsindex) { //Then addyL is next to the abstract symbol
		addyL = ac.a[addyL].prev->arrayaddress;
		backcounter++;
		arrayAddy = addyL;
		return true;
	}
	
	else { //Then addyR is
		addyR = ac.a[addyR].next->arrayaddress;
		forwardcounter++;
		arrayAddy = addyR;
		return true;
	}
	
	return false;
}

int countNumTimesEqual (config& c, int pos, abstrconfig& ac, int& arrayAddy, bool righthanded) {
//Counts the number of times c follows the pattern of ac at arrayAddy.
//To the right if righthanded, to the left otherwise.
	int numTimesSoFar = 0;
	bool haveEqualledSoFar = true;
	int i;
	
	if (righthanded) {
		while (pos + ac.a[arrayAddy].baselen <= c.len && haveEqualledSoFar) {
			for (i=0; i < ac.a[arrayAddy].baselen; i++) {
				if (c.t.a[pos + i] != ac.a[arrayAddy].base[i]) {
					haveEqualledSoFar = false;
					break;
				}
			}
			if (haveEqualledSoFar) {
				numTimesSoFar++;
				pos += ac.a[arrayAddy].baselen;
			}
		}
		return numTimesSoFar;
	}

	else {
		while (pos - ac.a[arrayAddy].baselen >= -1 && haveEqualledSoFar) {
			for (i=0; i < ac.a[arrayAddy].baselen; i++) {
				if (c.t.a[pos - i] != ac.a[arrayAddy].base[ac.a[arrayAddy].baselen - i - 1]) {
					haveEqualledSoFar = false;
					break;
				}
			}
			if (haveEqualledSoFar) {
				numTimesSoFar++;
				pos -= ac.a[arrayAddy].baselen;
			}
		}
		return numTimesSoFar;
	}	
}

void confReplace (config& c, abstrconfig& ac, int numTimesToDo) {
	//to fix: probably doesn't work when ac.len > 1 but head points at abstract bit.
	int addyL, addyR;
	addyL = addyR = ac.pos;
	int placeL, placeR;
	placeL = placeR = c.pos;
	
	//cout << "I was instructed to do " << numTimesToDo << " replacements.\n";
	
	bool isRightHanded;
	
	if (ac.len > 1) {
		while (addyL != ac.lhsindex && ac.a[addyL].prev->exp.a == 0) {
			cout << "Now replacing c's symbol " << c.t.a[placeL] << " at place " << placeL << " with ac's " << ac.a[addyL].base[0] << " at " << addyL << ".\n";
			c.t.a[placeL] = ac.a[addyL].base[0];
			addyL = ac.a[addyL].prev->arrayaddress;
			placeL--;
		}
		cout << "Now replacing c's symbol " << c.t.a[placeL] << " at place " << placeL << " with ac's " << ac.a[addyL].base[0] << " at " << addyL << ".\n";
		c.t.a[placeL] = ac.a[addyL].base[0];
		
		while (addyR != ac.rhsindex && ac.a[addyR].next->exp.a == 0) {
			cout << "Now replacing c's symbol " << c.t.a[placeR] << " at place " << placeR << " with ac's " << ac.a[addyR].base[0] << " at " << addyR << ".\n";
			c.t.a[placeR] = ac.a[addyR].base[0];
			addyR = ac.a[addyR].next->arrayaddress;
			placeR++;
		}
		cout << "Now replacing c's symbol " << c.t.a[placeR] << " at place " << placeR << " with ac's " << ac.a[addyR].base[0] << " at " << addyR << ".\n";
		c.t.a[placeR] = ac.a[addyR].base[0];
		
		if (addyL != ac.lhsindex) {
			addyL = ac.a[addyL].prev->arrayaddress;
			placeL--;
			isRightHanded = false;
		}
		else {
			addyR = ac.a[addyR].next->arrayaddress;
			placeR++;
			isRightHanded = true;
		}
	}
	else {
		if (ac.side == 0) isRightHanded = true;
		else isRightHanded = false;
	}
	
	if (!isRightHanded) { //i.e., if the abstract portion is on the left
		for (int i = 0; i < numTimesToDo; i++) {
			for (int j = ac.a[addyL].baselen - 1; j >= 0; j--) {
				c.t.a[placeL] = ac.a[addyL].base[j];
				placeL--;
			}			
		}
		c.pos = placeL;
	}
	
	else {
		for (int i = 0; i < numTimesToDo; i++) {
			for (int j = 0; j < ac.a[addyR].baselen; j++) {
				c.t.a[placeR] = ac.a[addyR].base[j];
				placeR++;
			}
		}
		c.pos = placeR;
	}	
}

int eval (expr e, int number) {
	return e.a * number + e.b;
}
