//Turing machine emulator for Busy Beaver problem
//Daniel Briggs, 2010

#include <iostream>
#include <fstream>
#include <ctime>
#include <string>
#include "structs.cpp"
#include "oldrun.h"
#include "discounts.h"
#include "run.h"
#include "config.h"
#include "TNF.h"
#include "skelet.h"
#include "runcomp.h"
#include "induction.h"
#include "runcomp2.h"
#include <cstdlib>
#include <cstring>
using namespace std;

int main (int argc, char * const argv[]) {
	machine M;
	M.n=5;
	clock_t start = clock();
	//int s=0, s3=0, s4=0; //s2=0;
	time_t seconds;
	time(&seconds);
	/*srand((unsigned int) seconds);
	const int numtries=10000;
	machine* Ma = new machine[numtries];
	makemachines(Ma,numtries);
	std::cout << "s4 (no transition to halt) WAS, " << s4 << '\n';
	std::cout << "s3 (4-state machine, of rest) WAS, " << s3 << '\n';
	std::cout << "s (halts, of rest) WAS, " << s << '\n';
	std::cout << 10000-s4-s3-s;
	//std::cout << "s2 (obvious loops) WAS, " << s2 << '\n';
	//std::cout << "s3 (less obvious) WAS, " << s3 << '\n';
	std::cout << "TIME WAS, " << ( ( std::clock() - start ) / (double)CLOCKS_PER_SEC ) <<'\n';
	s4=0; s3=0; s=0;
	int sbam=0, s5=0;
	const int savetime=60;
	for (int i=0; i<numtries; i++) {
		int q2=loopcheck3(Ma[i]);s4+=q2;
		int q3;
		if (!q2) {q3=four_s_m(Ma[i]);s3+=q3;}
		int q3half=0, q4=0;
		if (!q2 && !q3) {q3half=run(Ma[i],100); s+=q3half;}
		if (!q2 && !q3 && !q3half) {q4=runsmart(Ma[i],110); sbam+=q4;}
		if (!q2 && !q3 && !q3half && !q4) s5+=runsave(Ma[i],savetime);
	}
	
	std::cout << "UTILIZING TREE.\n";
	std::cout << "s4 (no transition to halt) WAS, " << s4 << '\n';
	std::cout << "s3 (4-state machine, of rest) WAS, " << s3 << '\n';
	std::cout << "s (halts, of rest) WAS, " << s << '\n';
	std::cout << "sbam (fails the S(4) test) WAS, " << s << '\n';
	std::cout << "s5 (repeat configs in first " << savetime << ") WAS, " << s5 << '\n';
	std::cout << numtries-s4-s3-s-sbam-s5 << " machines left out of " << numtries << ".\n";
	//std::cout << "s2 (obvious loops) WAS, " << s2 << '\n';
	//std::cout << "s3 (less obvious) WAS, " << s3 << '\n';
	std::cout << "TIME WAS, " << ( ( std::clock() - start ) / (double)CLOCKS_PER_SEC ) <<'\n';*/
	
//Can do with or without custom config on 6th line.
	
	int whichone, runlen /*sometimes long long*/, tapelen, spot, mod;
	char* somestring=new char[10000];
	char* stateforit=new char[1];
	config someconfig;
	string line;
	ifstream infile ("./instr.txt");
	bool custom_input = false;
	if (infile.is_open()) {
		if (!infile.eof()) getline(infile,line);
		whichone = atoi(line.c_str());
		if (!infile.eof()) getline(infile,line);
		runlen = atoi(line.c_str());
		if (!infile.eof()) getline(infile,line);
		tapelen = atoi(line.c_str());
		if (!infile.eof()) getline(infile,line);
		spot = atoi(line.c_str());
		if (!infile.eof()) getline(infile,line);
		mod = atoi(line.c_str());
		if (!infile.eof()) {
			infile >> somestring;
			custom_input = true;
			if (!infile.eof()) infile >> stateforit;
			strcat(somestring, " ");
			strcat(somestring, stateforit);
			if (configin(somestring,strlen(somestring),someconfig)) {
				cout << "Custom config came in.\n";
			}
		}
	}
	skeletfill(M,whichone);
	start = clock();
	
	if (!custom_input) runwithoutput(M,runlen,tapelen,spot,mod);
	else runwithoutput(M,runlen,someconfig.len,someconfig.pos,someconfig);

	
	/*for (int whichone=1; whichone<=42; whichone++) {
		skeletfill(M,whichone,0);
		runwithoutput(M,1005,170,85,1000);
	}*/
	
	
	//runwithhackneyedoutput(M,100000000,8000,7500,1);
	//runwithawesomeoutput (M, 5, 180, 90, 1);	
	//runwithawesomeoutput (M,100,50,25,1);
	std::cout << "TIME WAS, " << (clock()-start)/(double)CLOCKS_PER_SEC <<'\n';	
		
	/*int whichone=1;
	skeletfill(M,whichone);*/
	config c;
	c.len=1;
	c.t.a=new bool[1];
	c.t.a[0]=0;
	int B=1;
	c.s=B;
	c.pos=0;
	configout(c);
	cout << "\n";
	
	start = clock();
	
	/*int room=1000;
	config* cc=new config[room];
	int howmany=allcomefrom(cc, M, c, 10, room);
	for (int index=0; index<howmany; index++)
		configout(cc[index]);
	cout << "There were " << howmany << " of them\n";
	
	 for (int k=0; k<howmany; k++) {
	 for (int kk=0; kk<k; kk++) {
	 if (eql(cc[k],cc[kk])) {
	 reduce(cc,k,howmany);
	 k--;
	 howmany--;
	 break;
	 }
	 }
	 }*/
	
	int howmany=0;
	for (int funindex=1; funindex<=3; funindex++) {
		int room=1000;
		config* cc=new config[room];
		int howmanynow=multicomefrom(cc, M, c, funindex, room);
		for (int index=0; index<howmanynow; index++) {
			configout(cc[index]);
			cout << "\n";
		}
		cout << "There were " << howmanynow << " of them at level " << funindex<< ".\n\n";
		howmany+=howmanynow;
	}
	
	cout << "Which comes down to " << howmany << " of them\n";
	
	std::cout << "TIME WAS, " << (clock()-start)/(double)CLOCKS_PER_SEC <<'\n';
	
	
	compsymbol ss[5];
	ss[0].baselen=1;
	ss[1].baselen=1;
	ss[2].baselen=2;
	ss[3].baselen=3;
	ss[4].baselen=4;
	for (int icky=0; icky<5; icky++) ss[icky].base=new bool[ss[icky].baselen];
	ss[0].base[0]=0;													ss[0].exp=2;
	ss[1].base[0]=1;													ss[1].exp=9;
	ss[2].base[0]=0; ss[2].base[1]=0;									ss[2].exp=11;
	ss[3].base[0]=0; ss[3].base[1]=1; ss[3].base[2]=1;					ss[3].exp=1;
	ss[4].base[0]=1; ss[4].base[1]=0; ss[4].base[2]=0; ss[4].base[3]=0;	ss[4].exp=1;
	
	compconfig conf;
	
	conf.len=5;
	conf.s=3;
	conf.pos=2;
	conf.side=0;
	conf.lhsindex=0;
	
	conf.a=new compsymbol[5];
    
	for (int i=conf.lhsindex; i<conf.len; i++) {
		oldcopycompsymbol(ss[i],conf.a[i]);
		if (i<4) conf.a[i].next=&conf.a[i+1];
		else conf.a[i].next=NULL;
		if (i>0) conf.a[i].prev=&conf.a[i-1];
		else conf.a[i].prev=NULL;
		conf.a[i].arrayaddress=i;
	}
	
	compconfigout(conf);
	
	cout << "\n";
	
	/*abstrsymbol sss[5];
	sss[0].base='a'; sss[0].exp.a=0;  sss[0].exp.b=1;
	sss[1].base='b'; sss[1].exp.a=1;  sss[1].exp.b=0;
	sss[2].base='c'; sss[2].exp.a=1; sss[2].exp.b=1;
	sss[3].base='d'; sss[3].exp.a=2;  sss[3].exp.b=0;
	sss[4].base='e'; sss[4].exp.a=5;  sss[4].exp.b=3;
	
	abstrconfig aconf;
	
	aconf.len=5;
	aconf.s=3;
	aconf.pos=2;
	aconf.side=0;
	
	aconf.a=new abstrsymbol[5];
    
	for (int i=0; i<5; i++) {
		copyabstrsymbol(sss[i],aconf.a[i]);
		if (i<4) aconf.a[i].next=&aconf.a[i+1];
		if (i>0) aconf.a[i].prev=&aconf.a[i-1];
		aconf.a[i].arrayaddress=i;
	}
	
	abstrconfigout(aconf);
	
	cout << "\n\n";*/
	
	cout << "Type 0 for concrete, 1 for abstract, 2 for compression, 3 for run,\n";
	cout << "4 for runonassumptions, 5 for apply, 6 for LR_Type,\n";
	cout << "7 for largestSubstringUpToAbstrPointMatch, 8 for countNumTimesEqual,\n";
	cout << "9 for confReplace, 10 for eval.\n";
	
	int pq;
	cin>>pq;
	if (pq==0) {
		char* somestring=new char[100];
		char* stateforit=new char[1];
		cin >> somestring;
		cin >> stateforit;
		strcat(somestring, " ");
		strcat(somestring, stateforit);
		cout << strlen(somestring) << " is its length\n";
		compconfig someconfig;
		if (compconfigin(somestring,strlen(somestring),someconfig)) {
			cout << "It came in!\n";
			cout << "It has " << someconfig.len << " symbols. The tape head attached on the " << someconfig.side << " side of symbol number " << someconfig.pos << ".";
			cout << "It is in state " << someconfig.s << ". Its lhsindex is of course " << someconfig.lhsindex << "\n";
			compconfigout(someconfig);
		}
		else return 0;
		
		cout << "\n\n";
		
		char* somestring2=new char[100];
		char* stateforit2=new char[1];
		cin >> somestring2;
		cin >> stateforit2;
		strcat(somestring2, " ");
		strcat(somestring2, stateforit2);
		cout << strlen(somestring2) << " is its length\n";
		compconfig someconfig2;
		if (compconfigin(somestring2,strlen(somestring2),someconfig2)) {
			cout << "It came in!\n";
			cout << "It has " << someconfig2.len << " symbols. The tape head attached on the " << someconfig2.side << " side of symbol number " << someconfig2.pos << ".";
			cout << "It is in state " << someconfig2.s << ". Its lhsindex is of course " << someconfig2.lhsindex << "\n";
			compconfigout(someconfig2);
			
			if (eql(someconfig,someconfig2)) cout << "WHOA.\n";
			else cout << "OH WELL...\n";	
		}
		else return 0;
	}
	else if (pq==1) {
		char* somestring=new char[100];
		char* stateforit=new char[1];
		cin >> somestring;
		cin >> stateforit;
		strcat(somestring, " ");
		strcat(somestring, stateforit);
		cout << strlen(somestring) << " is its length\n";
		abstrconfig someconfig;
		if (abstrconfigin(somestring,strlen(somestring),someconfig)) {
			cout << "It came in!\n";
			cout << "It has " << someconfig.len << " symbols. The tape head attached on the " << someconfig.side << " side of symbol number " << someconfig.pos << ".";
			cout << "It is in state " << someconfig.s << ". Its lhsindex is of course " << someconfig.lhsindex << "\n";
			abstrconfigout(someconfig);
		}
		else return 0;
		
		cout << "\n\n";
		
		char* somestring2=new char[100];
		char* stateforit2=new char[1];
		cin >> somestring2;
		cin >> stateforit2;
		strcat(somestring2, " ");
		strcat(somestring2, stateforit2);
		cout << strlen(somestring2) << " is its length\n";
		abstrconfig someconfig2;
		if (abstrconfigin(somestring2,strlen(somestring2),someconfig2)) {
			cout << "It came in!\n";
			cout << "It has " << someconfig2.len << " symbols. The tape head attached on the " << someconfig2.side << " side of symbol number " << someconfig2.pos << ".";
			cout << "It is in state " << someconfig2.s << ". Its lhsindex is of course " << someconfig2.lhsindex << "\n";
			abstrconfigout(someconfig2);
			cout << "\n";
		}
		else return 0;
		
		if (eqlexact(someconfig,someconfig2)) cout << "They are exactly equal.\n";
		else cout << "They are not exactly equal.";
	}
	else if (pq==2) {
		char* somestring=new char[1000];
		char* stateforit=new char[1];
		cin >> somestring;
		cin >> stateforit;
		strcat(somestring, " ");
		strcat(somestring, stateforit);
		config someconfig;
		if (configin(somestring,strlen(somestring),someconfig)) {
			cout << "It came in!\n";
			cout << "It has " << someconfig.len << " symbols. The tape head is at symbol number " << someconfig.pos << ". ";
			cout << "It is in state " << someconfig.s << ".\n";
			compconfig someconfig2;
			compress(someconfig,someconfig2);
			cout << "Configuration compressed!\n";
			compconfigout(someconfig2);
		}
		else return 0;
	}
	else if (pq==3) {
		char* somestring=new char[1000];
		char* stateforit=new char[1];
		cin >> somestring;
		cin >> stateforit;
		strcat(somestring, " ");
		strcat(somestring, stateforit);
		config someconfig;
		if (configin(somestring,strlen(somestring),someconfig)) {
			runwithoutput(M,1000000,someconfig.len,someconfig.pos,someconfig);
		}
		else return 0;
	}
	else if (pq == 4) {
		assumptionlist al;
		al.a = new assumption[1000];
		al.len = 0;
		config c;
		int AssumptionIndex = 0;
		char* line_input = new char[10000];
		char* state_input = new char[1];
		char* line_output = new char[10000];
		char* state_output = new char[1];
		char* line_c = new char[100000];
		char* state_c = new char[1];
		int numbigsteps;
		ifstream infile1 ("./runonassum.txt");
		//This file should read: al[0].input, al[0].output, al[0].num, al[1].input, al[1].output, al[1].num, ...,
		//"----", c, numbigsteps
		if (infile1.is_open()) {
			infile1 >> line_input;
			while (line_input[0] != '-') {
				infile1 >> state_input;
				strcat(line_input, " ");
				strcat(line_input, state_input);
				cout << "Assumption #" << AssumptionIndex << "'s input is (string): " << line_input << "\n";
				if (abstrconfigin(line_input,strlen(line_input),al.a[AssumptionIndex].input)) {
					cout << "al.a[" << AssumptionIndex << "].input came in!\n";
					cout << "It has " << al.a[AssumptionIndex].input.len << " symbols. The tape head attached on the " << al.a[AssumptionIndex].input.side << " side of symbol number " << al.a[AssumptionIndex].input.pos << ".";
					cout << "It is in state " << al.a[AssumptionIndex].input.s << ". Its lhsindex is of course " << al.a[AssumptionIndex].input.lhsindex << ".\n And it itself is: ";
					abstrconfigout(al.a[AssumptionIndex].input);
					cout << "\n";
				}
				infile1 >> line_output;
				infile1 >> state_output;
				strcat(line_output, " ");
				strcat(line_output, state_output);
				cout << "Assumption #" << AssumptionIndex << "'s output is (string): " << line_output << "\n";
				if (abstrconfigin(line_output,strlen(line_output),al.a[AssumptionIndex].output)) {
					cout << "al.a[" << AssumptionIndex << "].output came in!\n";
					cout << "It has " << al.a[AssumptionIndex].output.len << " symbols. The tape head attached on the " << al.a[AssumptionIndex].output.side << " side of symbol number " << al.a[AssumptionIndex].output.pos << ".";
					cout << "It is in state " << al.a[AssumptionIndex].output.s << ". Its lhsindex is of course " << al.a[AssumptionIndex].output.lhsindex << ".\n And it itself is: ";
					abstrconfigout(al.a[AssumptionIndex].output);
					cout << "\n";
				}
				infile1 >> al.a[AssumptionIndex].num.a;
				infile1 >> al.a[AssumptionIndex].num.b;
				cout << "Assumption #" << AssumptionIndex << "'s num is: " << al.a[AssumptionIndex].num.a << "N+" << al.a[AssumptionIndex].num.b << "\n";
				
				AssumptionIndex++;
				infile1 >> line_input;
			}
			al.len = AssumptionIndex;
			
			infile1 >> line_c;
			infile1 >> state_c;
			strcat(line_c, " ");
			strcat(line_c, state_c);
			cout << "The configuration to apply to is (string): " << line_c << "\n";
			if (configin(line_c,strlen(line_c),c)) {
				cout << "c came in!\n";
				cout << "It has " << c.len << " symbols. The tape head is at symbol number " << c.pos << ".";
				cout << "It is in state " << c.s << ".\n And it itself is: ";
				configout(c);
				cout << "\n";
				infile1 >> numbigsteps;
				runonassumptions(M, c, al, numbigsteps);
			}
		}
	}
	else if (pq == 5) {
		assumption as;
		config c;
		char* line_input = new char[10000];
		char* state_input = new char[1];
		char* line_output = new char[10000];
		char* state_output = new char[1];
		char* line_c = new char[10000];
		char* state_c = new char[1];
		ifstream infile1 ("./confassum.txt");
		//This file should read: as.input, as.output, as.num, c 
		if (infile1.is_open()) {
			infile1 >> line_input;
			infile1 >> state_input;
			strcat(line_input, " ");
			strcat(line_input, state_input);
			cout << "The assumption's input is (string): " << line_input << "\n";
			if (abstrconfigin(line_input,strlen(line_input),as.input)) {
				cout << "as.input came in!\n";
				cout << "It has " << as.input.len << " symbols. The tape head attached on the " << as.input.side << " side of symbol number " << as.input.pos << ".";
				cout << "It is in state " << as.input.s << ". Its lhsindex is of course " << as.input.lhsindex << ".\n And it itself is: ";
				abstrconfigout(as.input);
				cout << "\n";
			}
			infile1 >> line_output;
			infile1 >> state_output;
			strcat(line_output, " ");
			strcat(line_output, state_output);
			cout << "The assumption's output is (string): " << line_output << "\n";
			if (abstrconfigin(line_output,strlen(line_output),as.output)) {
				cout << "as.output came in!\n";
				cout << "It has " << as.output.len << " symbols. The tape head attached on the " << as.output.side << " side of symbol number " << as.output.pos << ".";
				cout << "It is in state " << as.output.s << ". Its lhsindex is of course " << as.output.lhsindex << ".\n And it itself is: ";
				abstrconfigout(as.output);
				cout << "\n";
			}
			infile1 >> as.num.a;
			infile1 >> as.num.b;
			cout << "The assumption's num is: " << as.num.a << "N+" << as.num.b << "\n";			
			infile1 >> line_c;
			infile1 >> state_c;
			strcat(line_c, " ");
			strcat(line_c, state_c);
			cout << "The configuration to apply to is (string): " << line_c << "\n";
			if (configin(line_c,strlen(line_c),c)) {
				cout << "c came in!\n";
				cout << "It has " << c.len << " symbols. The tape head is at symbol number " << c.pos << ".";
				cout << "It is in state " << c.s << ".\n And it itself is: ";
				configout(c);
				cout << "\n";
				int howManyStepsItTook = apply (M, c, as);
				configout(c);
				cout << howManyStepsItTook << "\n";
			}			
		}		
	}
	else if (pq == 6) {
		abstrconfig ac;
		char* line1 = new char[10000];
		char* state1 = new char[1];
		ifstream infile1 ("./abconfig.txt");
		if (infile1.is_open()) {
			infile1 >> line1;
			cout << line1 << "\n";
			if (!infile1.eof()) infile1 >> state1;
			strcat(line1, " ");
			strcat(line1, state1);
			cout << line1 << "\n";
			if (abstrconfigin(line1,strlen(line1),ac)) {
				cout << "It came in!\n";
				cout << "It has " << ac.len << " symbols. The tape head attached on the " << ac.side << " side of symbol number " << ac.pos << ".";
				cout << "It is in state " << ac.s << ". Its lhsindex is of course " << ac.lhsindex << "\n";
				abstrconfigout(ac);
				cout << "\n";
			}
		}
		int LRi = LR_Type (ac);
		if (LRi == 1) cout << "It is of left type.\n";
		else if (LRi == 2) cout << "It is of right type.\n";
		else cout << "Undetermined type.\n";
	}
	else if (pq == 7) {
		abstrconfig ac;
		config c;
		char* line1 = new char[10000];
		char* line2 = new char[10000];
		char* state1 = new char[1];
		char* state2 = new char[1];
		ifstream infile1 ("./abconfig.txt");
		if (infile1.is_open()) {
			infile1 >> line1;
			if (!infile1.eof()) infile1 >> state1;
			strcat(line1, " ");
			strcat(line1, state1);
			cout << line1 << "\n";
			if (abstrconfigin(line1,strlen(line1),ac)) {
				cout << "ac came in!\n";
				cout << "It has " << ac.len << " symbols. The tape head attached on the " << ac.side << " side of symbol number " << ac.pos << ".";
				cout << "It is in state " << ac.s << ". Its lhsindex is of course " << ac.lhsindex << "\n";
				abstrconfigout(ac);
				cout << "\n";
			}
			infile1 >> line2;
			if (!infile1.eof()) infile1 >> state2;
			strcat(line2, " ");
			strcat(line2, state2);
			cout << line2 << "\n";
			if (configin(line2,strlen(line2),c)) {
				cout << "c came in!\n";
				cout << "It has " << c.len << " symbols. The tape head is at symbol number " << c.pos << ".";
				cout << "It is in state " << c.s << ".\n";
				configout(c);
				cout << "\n";
				int backcounter = 0, forwardcounter = 0, arrayAddy = ac.pos;
				if (largestSubstringUpToAbstrPointMatch (c, ac, arrayAddy, backcounter, forwardcounter)) {
					cout << "They match!";
				}
				else cout << "They don't match!";
				cout << "\n";
			}			
		}
	}
	else if (pq == 8) {
		abstrconfig ac;
		config c;
		char* line1 = new char[10000];
		char* line2 = new char[10000];
		char* state1 = new char[1];
		char* state2 = new char[1];
		ifstream infile1 ("./abconfig.txt");
		if (infile1.is_open()) {
			infile1 >> line1;
			if (!infile1.eof()) infile1 >> state1;
			strcat(line1, " ");
			strcat(line1, state1);
			cout << line1 << "\n";
			if (abstrconfigin(line1,strlen(line1),ac)) {
				cout << "ac came in!\n";
				cout << "It has " << ac.len << " symbols. The tape head attached on the " << ac.side << " side of symbol number " << ac.pos << ".";
				cout << "It is in state " << ac.s << ". Its lhsindex is of course " << ac.lhsindex << "\n";
				abstrconfigout(ac);
				cout << "\n";
			}
			infile1 >> line2;
			if (!infile1.eof()) infile1 >> state2;
			strcat(line2, " ");
			strcat(line2, state2);
			cout << line2 << "\n";
			if (configin(line2,strlen(line2),c)) {
				cout << "c came in!\n";
				cout << "It has " << c.len << " symbols. The tape head is at symbol number " << c.pos << ".";
				cout << "It is in state " << c.s << ".\n";
				configout(c);
				cout << "\n";
				int backcounter = 0, forwardcounter = 0, arrayAddy = ac.pos;
				if (largestSubstringUpToAbstrPointMatch (c, ac, arrayAddy, backcounter, forwardcounter)) {
					cout << "They match...\n";
					int pos;
					int handedness = LR_Type(ac);
					bool righthanded;
					if (handedness == 1) righthanded = false;
					else if (handedness == 2) righthanded = true;
					else {
						cout << "Hey you didn't even provide a valid abstrconfig.\n";
						return 0;
					}
					if (!righthanded) pos = c.pos - backcounter;
					else pos = c.pos + forwardcounter;
					int howmanytimes = countNumTimesEqual (c, pos, ac, arrayAddy, righthanded);
					cout << "They were equal " << howmanytimes << " times.\n";
				}
				else cout << "They don't even match!\n";
			}			
		}		
	}
	else if (pq == 9) {
		abstrconfig ac;
		config c;
		char* line1 = new char[10000];
		char* line2 = new char[10000];
		char* state1 = new char[1];
		char* state2 = new char[1];
		ifstream infile1 ("./abconfig.txt");
		if (infile1.is_open()) {
			infile1 >> line1;
			cout << line1 << "\n";
			if (!infile1.eof()) infile1 >> state1;
			strcat(line1, " ");
			strcat(line1, state1);
			cout << line1 << "\n";
			if (abstrconfigin(line1,strlen(line1),ac)) {
				cout << "ac came in!\n";
				cout << "It has " << ac.len << " symbols. The tape head attached on the " << ac.side << " side of symbol number " << ac.pos << ".";
				cout << "It is in state " << ac.s << ". Its lhsindex is of course " << ac.lhsindex << "\n";
				abstrconfigout(ac);
				cout << "\n";
			}
			infile1 >> line2;
			cout << line2 << "\n";
			if (!infile1.eof()) infile1 >> state2;
			strcat(line2, " ");
			strcat(line2, state2);
			cout << line2 << "\n";
			if (configin(line2,strlen(line2),c)) {
				cout << "c came in!\n";
				cout << "It has " << c.len << " symbols. The tape head is at symbol number " << c.pos << ".";
				cout << "It is in state " << c.s << ".\n";
				configout(c);
				cout << "\n" << "Number of times?\n";
				int numTimesToDo;
				cin >> numTimesToDo;
				confReplace (c, ac, numTimesToDo);
				configout(c);
				cout << "\n";
			}			
		}
	}
	else if (pq == 10) {
		expr e;
		int N;
		cout << "Expression e = aN + b;\n";
		cout << "a = ";
		cin >> e.a;
		cout << "b = ";
		cin >> e.b;
		cout << "N = ";
		cin >> N;
		cout << "The value is " << eval (e, N) << ".\n";
	}
	return 0;
}


